// Author 		: F. de la Parra
// Date			: April, 2019
// Description  : This program implements a "DNode" single-link linked list. 
//				  DNode is an external public class.
// Version      : 1.0


public class DLinkedList {
	// Entry point for the linked list.
	private DNode head;

	// Default constructor.
	public DLinkedList() {
		head = null;
	}

	// BEHAVIOUR METHODS
	
	// Add a DNode at the start of the linked list.
	public void addToStart(String itemName, int itemIndex) {
		head = new DNode(itemName, itemIndex, head);
	}
	
	// Delete the head node.
	public boolean deleteHeadNode() {
		if (head != null) {
			head = head.getLink();
			return true;
		}
		else
			return false;
		}
	
	// Compute the number of DNodes in the list.
	public int size(){
		int count = 0;
		DNode position = head;
		
		while (position != null) {
			count++;
			position = position.getLink( );
		}
		return count;
	}
	
	// Find out whether a DNode with a given content is in the linked list.
	public boolean contains(String item) {
		return (find(item) != null);
	}
 
	//Find the first DNode whose content is equal to a given target string.
	public DNode find(String target) {
		
		// Start at the entry point of the linked list.
		DNode position = head;
		String itemAtPosition;
		
		// Scan the linked list until the target is found.
		while (position != null) {
			itemAtPosition = position.getItem();
			if (itemAtPosition.equals(target))
				return position;
			position = position.getLink();
		}
		
		return null; //target was not found
	}
	
	// List the contents of all the DNodes in the linked list.
	public void outputList() {
		DNode position = head;
		while (position != null) {
			System.out.println(position.getItem() + " " + position.getIndex());
			position = position.getLink();
		}
	}
}